
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	ovlTv@̂P	PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LED0	Out	0:A1:_
	GP1:LED1	Out	0:A1:_
	GP2:LED2	Out	0:A1:_
	GP3:MCLR	-----
	GP4:SW1		In	0:IA1:It	vAbvp̂
	GP5:SW0		In	0:IA1:It	vAbvp̂

	N͂TbԂkdc_BĂovlɈڍsB

	@FLED0:100ms, LED1:50ms, LED2:10ms@c@Œ
	f[eBFĂTO

	荞݂͎gp^C}Õ^CAEg|[OB
	^C}Õ^CAEg͖PivZ͂POQSj
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

#include	<string.h>													//	񑀍n

#include	"_AtrDef.h"													//	萔Af[^^̐錾

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					0										//	ʏ\̈	PŎwip֎~j
#define	VER2					1										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					0										//	ʏ\̈	PŎwip֎~j
#define	VER4					1										//	ʈ̈	PŎwip֎~j	@̕sΉ

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ				4000000									//	gigj		c@__delay_XXňp

// ***************************************************************************
// *	f[^^															 *
// ***************************************************************************

typedef struct {														//	\tgEFAɂovl
	UB		Count;														//	ƗpJE^
	UB		State;														//	ԁiOFItAPFIj
	UB		MasterOn;													//	}X^JE^FIp
	UB		MasterOff;													//	}X^JE^FItp
} sLedPwm;

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** kdcȐff *****

#define	LED_DIAG_TIME			5000									//	ffp_ԁij

	//	***** kdc *****

enum {
	LED0,																//	OFkdcO
	LED1,																//	PFkdcP
	LED2,																//	QFkdcQ
	LED_TOTAL															//	RFkdc
};

#define	MASK_LED				0b00000111								//	kdcf[^̃}XN

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

union {
	UB	BYTE;															//	oCgANZXp
	struct {
		UINT	Led0	: 1;											//	kdcO
		UINT	Led1	: 1;											//	kdcP
		UINT	Led2	: 1;											//	kdcQ
		UINT	Dummy	: 5;											//	_~[
	} BIT;
} vLedData;																//	kdcҏWf[^

sLedPwm	vLedPwm[LED_TOTAL];												//	\tgEFAɂovl

UB	vPortData;															//	o̓|[g̃obNAbv

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

const	sLedPwm		tLedPwm[LED_TOTAL] = {								//	ovl̏f[^i̓sŃJE^̏l͂PAItԁj
//		Count	State	MasterOn	MasterOff
	{	1,		0,		50,			50	},								//	kdcO	50ms_A50msAf[eBTO
	{	1,		0,		25,			25	},								//	kdcP	25ms_A25msAf[eBTO
	{	1,		0,		 5,			 5	}								//	kdcQ	 5ms_A 5msAf[eBTO
};

// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************

	//	***** kdc *****

#define	mLed0_On()				vLedData.BIT.Led0 = 1					//	kdcO_
#define	mLed1_On()				vLedData.BIT.Led1 = 1					//	kdcP_
#define	mLed2_On()				vLedData.BIT.Led2 = 1					//	kdcQ_

#define	mLed0_Off()				vLedData.BIT.Led0 = 0					//	kdcO
#define	mLed1_Off()				vLedData.BIT.Led1 = 0					//	kdcP
#define	mLed2_Off()				vLedData.BIT.Led2 = 0					//	kdcQ

// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** }lWg *****

void	main(void);
void	LedPwmUpdate(sLedPwm *Info);
void	LedDiag(UH Count);

	//	***** foCX *****

void	DevInit(void);

	//	***** ^C} *****

void	TmInit(void);
void	TmWait(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎

	DevInit();															//	foCXݒ
	TmInit();															//	^C}ݒ				c@Ȍ͂PŃ^CAEg𔭐

	vLedData.BYTE =	0b00000000;											//	kdcS

	LedDiag(LED_DIAG_TIME);												//	kdc̑S_ff			c@̒œ_ҋ@AI͑S

	memcpy(vLedPwm, tLedPwm, sizeof(vLedPwm));							//	ovlݒ	c@ς݃f[^p

	//	*****  *****

	while (1) {															//	[vł

		//	***** Ƃkdc\XV *****

		TmWait();														//	^C}̃^CAEgҋ@	c@̊֐͏ɐ̐擪ɂȂ

		GPIO = (vPortData & MASK_LED) | vLedData.BYTE;					//	kdcҏWf[^ꊇXV	c@ŖXV

		//	***** ovl *****

		LedPwmUpdate(&vLedPwm[LED0]);									//	kdcÔovlXV
		if (vLedPwm[LED0].State)	mLed0_On();							//	Xe[gɂkdc
		else						mLed0_Off();						//	OFAOF_

		LedPwmUpdate(&vLedPwm[LED1]);									//	kdcP̂ovlXV
		if (vLedPwm[LED1].State)	mLed1_On();							//	Xe[gɂkdc
		else						mLed1_Off();						//	OFAOF_

		LedPwmUpdate(&vLedPwm[LED2]);									//	kdcQ̂ovlXV
		if (vLedPwm[LED2].State)	mLed2_On();							//	Xe[gɂkdc
		else						mLed2_Off();						//	OFAOF_
	}
}

//============================================================================
//	ovl̍XV
//----------------------------------------------------------------------------
//	́F	kdĉovli[AhX
//	óF	
//----------------------------------------------------------------------------
//	lF	w肳kdĉovlXV܂B
//============================================================================
void	LedPwmUpdate(sLedPwm *Info)
{
	Info->Count --;														//	JEgXV

	if (Info->Count == 0) {												//	JEgIH
		if (Info->State == 0) {											//	݃ItH
			Info->State = 1;											//	x̓I
			Info->Count = Info->MasterOn;								//	JEg̍Đݒ
		}
		else {															//	݃I
			Info->State = 0;											//	x̓It
			Info->Count = Info->MasterOff;								//	JEg̍Đݒ
		}
	}
}

//============================================================================
//	kdc̑S_ff
//----------------------------------------------------------------------------
//	́F	ێ񐔁iPPʂ̉񐔁j
//	óF	
//----------------------------------------------------------------------------
//	lF	Ă̂kdc_A܂B
//============================================================================
void	LedDiag(UH Count)
{
	//	***** ͂߂ *****

	if (Count != 0) {													//	ێ񐔂͂H

		//	***** kdc̓_ *****

		mLed0_On();		mLed1_On();		mLed2_On();						//	kdcS_
		GPIO = (vPortData & MASK_LED) | vLedData.BYTE;					//	o̓|[gꊇҏW

		//	***** Ԉێ *****

		while (Count--) {												//	ێ񐔂OɂȂ܂ŏ
			TmWait();													//	^C}̃^CAEgҋ@
		}

		//	***** kdc̏ *****

		mLed0_Off();	mLed1_Off();	mLed2_Off();					//	kdcS
		GPIO = (vPortData & MASK_LED) | vLedData.BYTE;					//	o̓|[gꊇҏW
	}
}

//	
//	
//
// 		foCX
//
//	
//	
void	Dev______(void) {}												//	op֐

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	vPortData		 =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FrvO						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FrvP						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						

	GPIO = vPortData;													//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	TRISIO =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FrvO						
																		//	bit04:GP4		1	́FrvP						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdcQ						
																		//	bit01:GP1		0	óFkdcP						
																		//	bit00:GP0		0	óFkdcO						
}

//	
//	
//
// 		^C}
//
//	
//	
void	Tm______(void) {}												//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Ȍݒs܂B
//			^CAEg͖PiPOQSʂjłB
//============================================================================
void	TmInit(void)
{
	//	***** ^C}Õ[hݒ *****

	CLRWDT();															//	vcs̃tbV	c@ʓIɓ삵ĂȂ̂Ōʖ
																		//								f[^V[gɋLڂĂ@𓥏P
//						 76543210	   76543210
	OPTION = (OPTION & 0b11010000) | 0b00000001;						//	IvVWX^		c@ݒς݂̒lC
																		//	bit07:GPPU		*	iύXȂj
																		//	bit06:INTEDG	*	iύXȂj
																		//	bit05:T0CS		0	^C}O͓NbN𗘗p		
																		//	bit04:T0SE		*	iύXȂj
																		//	bit03:PSA		0	vXP[̓^C}Oŗp		
																		//	bit02:PS2		0	vXP[͂S				
																		//	bit01:PS1		0		ij
																		//	bit00:PS0		1		ij

	//	***** ^C}Õ^CAEg󋵂 *****

	TMR0 = 0;															//	^C}OJE^̃NAivXP[ɃNAj
	T0IE = 0;															//	^C}O͋֎~
	T0IF = 0;															//	^C}Ov	c@slqOWX^̃I[o[t[
}

//============================================================================
//	^CAEgҋ@
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Õ^CAEgiPOQSʂjҋ@܂B
//			O̊֐sォÅ֐s̊Ԋu͈łB
//============================================================================
void	TmWait(void)
{
	while (T0IF == 0)	;												//	^C}O荞ݗv܂őҋ@
	T0IF = 0;															//	^C}Ov
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

